#!/usr/bin/env python3
import logging

import bspump
import bspump.avro
import bspump.common
import bspump.file
import bspump.trigger

###

L = logging.getLogger(__name__)

###


class SamplePipeline(bspump.Pipeline):
    def __init__(self, app, pipeline_id):
        super().__init__(app, pipeline_id)

        self.build(
            bspump.avro.AvroSource(app, self, config={"path": "./data/*.avro"}).on(
                bspump.trigger.RunOnceTrigger(app)
            ),
            bspump.common.PPrintSink(app, self),
        )

    def on_cycle_end(self, event_name, pipeline):
        """
        This ensures that at the end of the file scan, the target file is closed
        """


if __name__ == "__main__":
    app = bspump.BSPumpApplication()

    svc = app.get_service("bspump.PumpService")

    # Construct and register Pipeline
    pl = SamplePipeline(app, "SamplePipeline")
    svc.add_pipeline(pl)

    app.run()
